<template>
    <div>
        <div class="alert alert-danger" role="alert" v-if="invalid">
            The given credentials already exist or is invalid.
        </div>

        <div class="card">
            <div class="card-header">
                Sign Up!
            </div>

            <div class="card-body">
                <form @submit.prevent="onSubmit()">
                    <div class="form-group row mb-2">
                        <label class="col-md-2 col-form-label"
                               for="userNameId">Username</label>
                        <div class="col-md-8">
                            <input class="form-control"
                                   id="userNameId"
                                   type="text"
                                   v-model="username"
                                   placeholder="Username (required)"
                                   :class="{'is-invalid': $v.username.$error}"/>
                            <span class="invalid-feedback">
                                <span v-if="!$v.username.required">
                                    Please enter your username.
                                </span>
                                <span v-if="!$v.username.minLen">
                                    The username must be longer than {{ $v.username.$params.minLen.min }} characters.
                                </span>
                             </span>
                        </div>
                    </div>

                    <div class="form-group row mb-2">
                        <label class="col-md-2 col-form-label"
                               for="email">Email</label>
                        <div class="col-md-8">
                            <input class="form-control"
                                   id="email"
                                   type="email"
                                   v-model="email"
                                   placeholder="Email (required)"
                                   :class="{'is-invalid': $v.email.$error}"/>
                            <span class="invalid-feedback">
                                <span v-if="!$v.email.required">
                                    Please enter your email.
                                </span>
                             </span>
                        </div>
                    </div>

                    <div class="form-group row mb-2">
                        <label class="col-md-2 col-form-label"
                               for="phoneNumber">Phone Number</label>
                        <div class="col-md-8">
                            <input class="form-control"
                                   id="phoneNumber"
                                   type="number"
                                   v-model="phoneNumber"
                                   placeholder="Phone Number (required)"
                                   :class="{'is-invalid': $v.phoneNumber.$error}"/>
                            <span class="invalid-feedback">
                                <span v-if="!$v.phoneNumber.required">
                                    Please enter your phone number.
                                </span>
                             </span>
                        </div>
                    </div>

                    <div class="form-group row mb-2">
                        <label class="col-md-2 col-form-label"
                               for="firstNameId">First Name</label>
                        <div class="col-md-8">
                            <input class="form-control"
                                   id="firstNameId"
                                   type="text"
                                   v-model="firstName"
                                   placeholder="First Name (required)"
                                   :class="{'is-invalid': $v.firstName.$error}"/>

                        </div>
                        <span class="invalid-feedback">
                                <span v-if="!$v.firstName.required">
                                    Please enter your first name.
                                </span>
                                <span v-if="!$v.firstName.minLen">
                                    The first name must be longer than {{ $v.firstName.$params.minLen.min }} characters.
                                </span>
                             </span>
                    </div>

                    <div class="form-group row mb-2">
                        <label class="col-md-2 col-form-label"
                               for="lastNameId">Last Name</label>
                        <div class="col-md-8">
                            <input class="form-control"
                                   id="lastNameId"
                                   type="text"
                                   v-model="lastName"
                                   placeholder="Last Name (required)"
                                   :class="{'is-invalid': $v.lastName.$error}"/>
                            <span class="invalid-feedback">
                                <span v-if="!$v.lastName.required">
                                    Please enter your last name.
                                </span>
                             </span>
                        </div>
                    </div>

                    <div class="form-group row mb-2">
                        <label class="col-md-2 col-form-label"
                               for="password">Password</label>
                        <div class="col-md-8">
                            <input class="form-control"
                                   id="password"
                                   type="password"
                                   v-model="password"
                                   placeholder="Password (required)"
                                   :class="{'is-invalid': $v.password.$error}"/>
                            <span class="invalid-feedback">
                                <span v-if="!$v.password.required">
                                    Please enter your password.
                                </span>
                                <span v-if="!$v.password.minLen">
                                    The password must be longer than {{ $v.password.$params.minLen.min }} characters.
                                </span>
                             </span>
                        </div>
                    </div>

                    <div class="form-group row mb-2">
                        <div class="offset-md-2 col-md-4">
                            <button class="btn btn-primary mr-3"
                                    type="submit">
                                Sign up
                            </button>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </div>
</template>

<script>
    import {required, minLength} from 'vuelidate/lib/validators';
    import axios from 'axios';
    export default {
        data() {
            return {
                username: '',
                email: '',
                firstName: '',
                lastName: '',
                password: '',
                phoneNumber: '',
                invalid: false
            }
        },
        validations: {
            username: {
                required,
                minLen: minLength(5)
            },
            email: {
                required
            },
            firstName: {
                required,
                minLen: minLength(3)
            },
            lastName: {
                required
            },
            password: {
                required,
                minLen: minLength(3)
            },
            phoneNumber: {
                required
            }
        },
        methods: {
            onSubmit() {
                this.$v.$touch();
                let userData = new FormData();
                userData.append('username', this.username)
                userData.append('email', this.email)
                userData.append('first_name', this.firstName)
                userData.append('last_name', this.lastName)
                userData.append('password', this.password)
                userData.append('phone_number', this.phoneNumber)
                axios.post('http://localhost:8000/api/register.php', userData)
                    .then(() => {
                        this.$router.replace('/login')
                }).catch((err) => {
                    console.log(err);
                    this.invalid = true;
                });
            }
        }
    }
</script>